'
' ####################
' #####  PROLOG  #####
' ####################
'
' Use IsMatch regex function to test patterns
'
VERSION "0.0001"
CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
	IMPORT  "gnu_regex"
'	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

DECLARE FUNCTION Entry ()
DECLARE FUNCTION IsMatch (input$, pattern$, @match$)
DECLARE FUNCTION IsAlphaNumeric (strToCheck$)
DECLARE FUNCTION IsAlpha (strToCheck$)
DECLARE FUNCTION IsNumber (strNumber$)
DECLARE FUNCTION IsPositiveNumber (strNumber$)
DECLARE FUNCTION IsInteger (strNumber$)
DECLARE FUNCTION IsPositiveInteger (strNumber$)
DECLARE FUNCTION IsHexDecimal (strToCheck$)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	PRINT "abcde12345: IsAlphaNumeric: "; IsAlphaNumeric ("ab12321061")
	PRINT "9876543210: IsAlphaNumeric: "; IsAlphaNumeric ("9876543210")
	PRINT "AbcdeFghiJ: IsAlphaNumeric: "; IsAlphaNumeric ("abcdefghij")
	PRINT "&abcdefgh$: IsAlphaNumeric: "; IsAlphaNumeric ("&abcdefgh$")
	
	PRINT
	PRINT "abcde12345: IsAlpha: "; IsAlpha ("ab12321061")
	PRINT "9876543210: IsAlpha: "; IsAlpha ("9876543210")
	PRINT "AbcdeFghiJ: IsAlpha: "; IsAlpha ("abcdefghij")
	PRINT "&abcdefgh$: IsAlpha: "; IsAlpha ("&abcdefgh$")
	
	PRINT
	PRINT "abcde12345: IsNumber: "; IsNumber ("ab12321061")
	PRINT "9876543210: IsNumber: "; IsNumber ("9876543210")
	PRINT "AbcdeFghiJ: IsNumber: "; IsNumber ("abcdefghij")
	PRINT "&abcdefgh$: IsNumber: "; IsNumber ("&abcdefgh$")
	PRINT "9876543.21: IsNumber: "; IsNumber ("9876543.21")
	PRINT "-876543210: IsNumber: "; IsNumber ("-876543210")
	PRINT "+876543210: IsNumber: "; IsNumber ("+876543210")
	PRINT "0.00543210: IsNumber: "; IsNumber ("0.00543210")
	PRINT "+-98765432: IsNumber: "; IsNumber ("+-98765432")
	PRINT "++98765432: IsNumber: "; IsNumber ("++98765432")
	PRINT "+98765432-: IsNumber: "; IsNumber ("+98765432-")
	PRINT "-98765432-: IsNumber: "; IsNumber ("-98765432-")
	PRINT "9876543..0: IsNumber: "; IsNumber ("9876543..0")
		
	PRINT	
	PRINT "abcde12345: IsPositiveNumber: "; IsPositiveNumber ("ab12321061")
	PRINT "9876543210: IsPositiveNumber: "; IsPositiveNumber ("9876543210")
	PRINT "AbcdeFghiJ: IsPositiveNumber: "; IsPositiveNumber ("abcdefghij")
	PRINT "&abcdefgh$: IsPositiveNumber: "; IsPositiveNumber ("&abcdefgh$")
	PRINT "9876543.21: IsPositiveNumber: "; IsPositiveNumber ("9876543.21")
	PRINT "-876543210: IsPositiveNumber: "; IsPositiveNumber ("-876543210")
	PRINT "+876543210: IsPositiveNumber: "; IsPositiveNumber ("+876543210")
	PRINT "0.00543210: IsPositiveNumber: "; IsPositiveNumber ("0.00543210")
	PRINT "+-98765432: IsPositiveNumber: "; IsPositiveNumber ("+-98765432")
	PRINT "++98765432: IsPositiveNumber: "; IsPositiveNumber ("++98765432")
	PRINT "+98765432-: IsPositiveNumber: "; IsPositiveNumber ("+98765432-")
	PRINT "-98765432-: IsPositiveNumber: "; IsPositiveNumber ("-98765432-")
	PRINT "9876543..0: IsPositiveNumber: "; IsPositiveNumber ("9876543..0")
		
	PRINT	
	PRINT "abcde12345: IsInteger: "; IsInteger ("ab12321061")
	PRINT "9876543210: IsInteger: "; IsInteger ("9876543210")
	PRINT "AbcdeFghiJ: IsInteger: "; IsInteger ("abcdefghij")
	PRINT "&abcdefgh$: IsInteger: "; IsInteger ("&abcdefgh$")
	PRINT "9876543.21: IsInteger: "; IsInteger ("9876543.21")
	PRINT "-876543210: IsInteger: "; IsInteger ("-876543210")
	PRINT "+876543210: IsInteger: "; IsInteger ("+876543210")
	PRINT "0.00543210: IsInteger: "; IsInteger ("0.00543210")
	PRINT "+-98765432: IsInteger: "; IsInteger ("+-98765432")
	PRINT "++98765432: IsInteger: "; IsInteger ("++98765432")
	PRINT "+98765432-: IsInteger: "; IsInteger ("+98765432-")
	PRINT "-98765432-: IsInteger: "; IsInteger ("-98765432-")
	PRINT "9876543..0: IsInteger: "; IsInteger ("9876543..0")
		
	PRINT	
	PRINT "abcde12345: IsPositiveInteger: "; IsPositiveInteger ("ab12321061")
	PRINT "9876543210: IsPositiveInteger: "; IsPositiveInteger ("9876543210")
	PRINT "AbcdeFghiJ: IsPositiveInteger: "; IsPositiveInteger ("abcdefghij")
	PRINT "&abcdefgh$: IsPositiveInteger: "; IsPositiveInteger ("&abcdefgh$")
	PRINT "9876543.21: IsPositiveInteger: "; IsPositiveInteger ("9876543.21")
	PRINT "-876543210: IsPositiveInteger: "; IsPositiveInteger ("-876543210")
	PRINT "+876543210: IsPositiveInteger: "; IsPositiveInteger ("+876543210")
	PRINT "0.00543210: IsPositiveInteger: "; IsPositiveInteger ("0.00543210")
	PRINT "+-98765432: IsPositiveInteger: "; IsPositiveInteger ("+-98765432")
	PRINT "++98765432: IsPositiveInteger: "; IsPositiveInteger ("++98765432")
	PRINT "+98765432-: IsPositiveInteger: "; IsPositiveInteger ("+98765432-")
	PRINT "-98765432-: IsPositiveInteger: "; IsPositiveInteger ("-98765432-")
	PRINT "9876543..0: IsPositiveInteger: "; IsPositiveInteger ("9876543..0")	
	
	PRINT
	PRINT "0x000000: IsHexDecimal: "; IsHexDecimal ("0x000000")		
	PRINT "0x123456: IsHexDecimal: "; IsHexDecimal ("0x123456")
	PRINT "0xabcdef: IsHexDecimal: "; IsHexDecimal ("0xabcdef")
	PRINT "0xABC123: IsHexDecimal: "; IsHexDecimal ("0xABC123")	
	PRINT "0xABCEFG: IsHexDecimal: "; IsHexDecimal ("0xABCEFG")	
	PRINT "0Xabc123: IsHexDecimal: "; IsHexDecimal ("0Xabc123")
	PRINT "abcdef12: IsHexDecimal: "; IsHexDecimal ("abcdef12")
	PRINT "00x00fff: IsHexDecimal: "; IsHexDecimal ("00x00fff")
	PRINT "x00fffff: IsHexDecimal: "; IsHexDecimal ("x00fffff")
	PRINT "0xfffffff: IsHexDecimal: "; IsHexDecimal ("0xfffffff")
	PRINT "0x000000000: IsHexDecimal: "; IsHexDecimal ("0x000000000")
	PRINT "0x1: IsHexDecimal: "; IsHexDecimal ("0x1")

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

' Function to Check for AlphaNumeric.

FUNCTION IsAlphaNumeric (strToCheck$)

	match$ = ""
	RETURN !IsMatch (strToCheck$, "[^a-zA-Z0-9]", @match$)  
END FUNCTION 

' Function To test for Alphabets.

FUNCTION IsAlpha (strToCheck$)

	match$ = ""
	RETURN !IsMatch (strToCheck$, "[^a-zA-Z]", @match$)  
END FUNCTION

' Function to test whether the string is valid number or not

FUNCTION IsNumber (strNumber$)

		match$ = ""
		NotNumberPattern = IsMatch (strNumber$, "[^0-9.-]", @match$)
		 
		match$ = ""
		TwoDotPattern = IsMatch (strNumber$, "[0-9]*[.][0-9]*[.][0-9]*", @match$)

		match$ = ""
		TwoMinusPattern = IsMatch (strNumber$, "[0-9]*[-][0-9]*[-][0-9]*", @match$)

		strValidRealPattern$ = "^([-]|[.]|[-.]|[0-9])[0-9]*[.]*[0-9]+$"
    strValidIntegerPattern$ = "^([-]|[0-9])[0-9]*$"

		match$ = ""
		NumberPattern = IsMatch (strNumber$, "(" + strValidRealPattern$ + ")|(" + strValidIntegerPattern$ + ")", @match$)
		
    RETURN !NotNumberPattern && !TwoDotPattern && !TwoMinusPattern && NumberPattern
END FUNCTION 

' Function to Test for Positive Number both Integer & Real
	
FUNCTION IsPositiveNumber (strNumber$)

		match$ = ""
		NotPositivePattern = IsMatch (strNumber$, "[^0-9.]", @match$)
		
		match$ = ""
		PositivePattern = IsMatch (strNumber$, "^[.][0-9]+$|[0-9]*[.]*[0-9]+$", @match$)
				
		match$ = ""
		TwoDotPattern = IsMatch (strNumber$, "[0-9]*[.][0-9]*[.][0-9]*", @match$)		

    RETURN !NotPositivePattern && PositivePattern && !TwoDotPattern
END FUNCTION 

' Function to Test for Integers both Positive & Negative
	
FUNCTION IsInteger (strNumber$)

		match$ = ""
		NotIntPattern = IsMatch (strNumber$, "[^0-9-]", @match$)
		
		match$ = ""
		IntPattern = IsMatch (strNumber$, "^-[0-9]+$|^[0-9]+$", @match$)

    RETURN !NotIntPattern && IntPattern
END FUNCTION 

' Function to test for Positive Integers.
	
FUNCTION IsPositiveInteger (strNumber$)

		match$ = ""
		NotNaturalPattern = IsMatch (strNumber$, "[^0-9]", @match$)
		
		match$ = ""
		NaturalPattern = IsMatch (strNumber$, "0*[1-9][0-9]*", @match$)

    RETURN !NotNaturalPattern && NaturalPattern
END FUNCTION 

' Function to test for Hex Decimal 0xFFFFFF.

FUNCTION IsHexDecimal (strToCheck$)

	match$ = ""
	RETURN IsMatch (strToCheck$, "^0[xX][A-Fa-f0-9]{1,8}$", @match$)
END FUNCTION 

'
' #####################
' #####  IsMatch  #####
' #####################
'
'
'
FUNCTION IsMatch (input$, pattern$, @match$)

	REGEX_T regex
	REGMATCH_T m

' Compile the regular expression
  error = regcomp (&regex, &pattern$, $$REG_EXTENDED) 
		
	IF error THEN
		regfree (&regex)
'		errbuf$ = NULL$(128)
'		regerror (error, &regex, &errbuf$, LEN(errbuf$))
'		PRINT "regcomp error: "; error; " : "; CSIZE$(errbuf$)
		RETURN $$FALSE
	END IF		
		
  ' Perform the match
	sAddr = &input$
	bAddr = sAddr
	error = regexec (&regex, sAddr, 1, &m, 0) ' find first match

	IF error THEN
'		errbuf$ = NULL$(128)
'		regerror (error, &regex, &errbuf$, LEN(errbuf$))
'		PRINT "regexec error: "; error; " : "; CSIZE$(errbuf$)
		regfree (&regex)
		RETURN $$FALSE
	END IF

	offset = sAddr - bAddr
	match$ = MID$(input$, offset + m.rm_so + 1, m.rm_eo - m.rm_so)
	RETURN $$TRUE
	
END FUNCTION
END PROGRAM